import { InvalidType } from './invalid-type';
type InternalPickOne<T, Keys extends keyof T> = {
    [K in Keys]: Required<Pick<T, K>> & Partial<Record<Exclude<Keys, K>, InvalidType<T>>>;
}[Keys];
export type RequireOnlyOne<T, Keys extends keyof T = keyof T> = Omit<T, Keys> & InternalPickOne<T, Keys>;
export {};
