import { IndexOptions } from './index-options';
import { CompositePrimaryKey } from './metadata/metadata-storage';
export declare const IsCompositePrimaryKey: (key: unknown) => key is CompositePrimaryKey<any>;
export interface TableOptions {
    name: string;
    partitionKey: string;
    sortKey?: string;
    indexes?: {
        [key: string]: IndexOptions;
    };
}
export declare class Table {
    private options;
    constructor(options: TableOptions);
    set name(value: string);
    get name(): string;
    get partitionKey(): string;
    get sortKey(): string | (string & import("./index-options").KeyAliasSchema<any>);
    usesCompositeKey(): boolean;
    getIndexByKey(key: string): IndexOptions;
}
